_ti89:
_nostub:
 xdef _ti89
 xdef _nostub
ROOM_SIZE = 5000
MAX_TIME = 20*1200
GF_START_GAME = 0
GF_END_GAME = 1
GF_ROOM_LOAD = 2
GF_WIN = 3
GF_GAME_OVER = 4
GF_TIME_UP = 5
GFS_START_GAME = 1
GFS_END_GAME = 2
GFS_WIN = 8
MAX_ACTIVE_ACTORS = 10
MAX_ACTORS = MAX_ACTIVE_ACTORS+10
AF_INUSE = 0
AF_COLLISION_ITEMS = 1
AF_COLLISION_ACTORS = 2
AF_DAMAGED_ON_BULLET = 3
AFS_INUSE = 1
AFS_COLLISION_ITEMS = 2
AFS_COLLISION_ACTORS = 4
AFS_DAMAGED_ON_BULLET = 8
AS_BIG = 0
AS_CAN_FIRE = 1
AS_DAMAGED = 2
AS_INVICIBLE = 3
AS_DIRECTION = 5
ASS_BIG = 1
ASS_CAN_FIRE = 2
ASS_DIRECTION = 32
A_x = 0
A_y = A_x+4
A_XSpeed = A_y+4
A_YSpeed = A_XSpeed+4
A_Width = A_YSpeed+4
A_Flags = A_Width+2
A_State = A_Flags+1
A_Height = A_State+1
A_Data = A_Height+2
A_pUpdate = A_Data+10
sACTOR = A_pUpdate+4
pScreen = 0
pOldScreen = pScreen+4
wScrollingX = pOldScreen+4
wRoomWidth = wScrollingX+2
pRoomExtraData = wRoomWidth+2
pWarp = pRoomExtraData+4
pWarpSave = pWarp+4
pPlatForm = pWarpSave+4
wRandomSeed = pPlatForm+4
uTime = wRandomSeed+2
bGameFlags = uTime+4
wCoins = bGameFlags+2
wLives = wCoins+2
uScore = wLives+2
pCollisionActor = uScore+4
bCollisionY = pCollisionActor+4
bCollisionX = bCollisionY+1
bKeys =  bCollisionX+1
bLastKeys = bKeys+1
Actors = bLastKeys+1
Debris = Actors+(MAX_ACTIVE_ACTORS*sACTOR)
CoinAnim = Debris+(4*sACTOR)
DeadEnemy = CoinAnim+sACTOR
FloatingScore = DeadEnemy+sACTOR
Bullet = FloatingScore+sACTOR
EnemyBullets = Bullet+sACTOR
Room = EnemyBullets+(2*sACTOR)
VirtualScreen = Room+ROOM_SIZE
HEAP_USED = VirtualScreen+3420
 movem.l d0-d7/a0-a7,-(a7)
 move.l #HEAP_USED,-(a7)
 move.l $c8,a0
 move.l 162*4(a0),a0
 jsr (a0)
 lea 4(a7),a7
 move.l a0,a6
 cmp.w #0,a0
 bne \0
 move.w #670,-(a7)
 move.l $c8,a0
 move.l 339*4(a0),a0
 jsr (a0)
\0:
 move.l #2000,-(a7)
 move.l $c8,a0
 move.l 162*4(a0),a0
 jsr (a0)
 lea 4(a7),a7
 move.l a0,pOldScreen(a6)
 bsr Screen_Save

 move.w #$0700,d0
 trap #1
 move.w #%1111111110,$600018

 move.b #GFS_START_GAME,bGameFlags(a6)
\1:
 bsr Room_Load
\2:
 bsr Screen_Clear
 bsr Keyboard_Update
 bsr Time_Update
 bsr Room_Update
 bsr Actors_Update
 bsr Scrolling_Update
 bsr Screen_Update
 
 bclr #GF_ROOM_LOAD,bGameFlags(a6)
 bne \1
 btst #GF_END_GAME,bGameFlags(a6)
 bne \4
 btst #7,bKeys(a6)
 bne \2
 btst #7,bLastKeys(a6)
 beq \2
 lea s_Pause(pc),a0
 bsr Screen_DrawStr
\3:
 bsr Keyboard_Update
 btst #7,bKeys(a6)
 bne \3
 btst #7,bLastKeys(a6)
 beq \3
 bra \2
\4: 
 bsr Screen_Restore

 clr.w d0
 trap #1

 move.l pOldScreen(a6),-(a7)
 beq \5
 move.l $c8,a0
 move.l 163*4(a0),a0
 jsr (a0)
\5:
 lea 4(a7),a7
 move.l a6,-(a7)
 move.l $c8,a0
 move.l 163*4(a0),a0
 jsr (a0)
 lea 4(a7),a7
 movem.l (a7)+,d0-d7/a0-a7
 rts
 
; a4 : sprite
; (d6.w,d7.w) : (x,y)
; uses d0-d1/a0-a4
Sprite_Draw:
 cmp.w #100,d7
 bge \9
 cmp.w #-8,d7
 ble \9
 move.w d6,d0
 move.w d7,d1
 sub.w wScrollingX(a6),d0
 move.l pScreen(a6),a0

 add.w d1,d1
 sub.w d1,a0
 lsl.w #4,d1
 add.w d1,a0

 move.b d0,d1
 and.b #$f,d1
 add.b #8,d1
 asr.w #3,d0
 bclr #0,d0
 add.w d0,a0
 
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,(a0)
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,30(a0)
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,60(a0)
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,90(a0)
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,120(a0)
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,150(a0)
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,180(a0)
 moveq #0,d0
 move.b (a4)+,d0
 ror.l d1,d0
 or.l d0,210(a0)
 rts

\9:
 addq.w #8,a4
 rts

Sprite2x1_Draw:
 bsr Sprite_Draw
 addq.w #8,d7
 bra Sprite_Draw

Sprite1x2_Draw:
 bsr Sprite_Draw
 addq.w #8,d6
 bra Sprite_Draw

Sprite2x2_Draw:
 bsr Sprite_Draw
 addq.w #8,d7
 bsr Sprite_Draw
 subq.w #8,d7
 addq.w #8,d6
 bsr Sprite_Draw
 addq.w #8,d7
 bra Sprite_Draw

Screen_Update:
 move.l pScreen(a6),a0
 move.l #$4c00,a1
 moveq #99,d0
\0:
 moveq #4,d1
\1:
 move.l (a0)+,(a1)+
 dbra d1,\1
 add.w #10,a0
 add.w #10,a1
 dbra d0,\0
 rts

Screen_Clear:
 move.l pScreen(a6),a0
 clr.l d0
 move.l d0,d1
 move.l d0,d2
 move.l d0,d3
 move.l d0,d4
 moveq #99,d5
\0:
 movem.l d0-d4,(a0)
 add.w #30,a0
 dbra d5,\0
 rts

Screen_Save:
 move.l #$4c00,a0 
 move.l pOldScreen(a6),a1
 cmp.w #0,a1
 beq \2
 moveq #99,d0
\0:
 moveq #4,d1
\1:
 move.l (a0)+,(a1)+
 dbra d1,\1
 add.w #10,a0
 dbra d0,\0
\2:
 rts

Screen_Restore:
 move.l #$4c00,a0 
 move.l pOldScreen(a6),a1
 cmp.w #0,a1
 beq \2
 moveq #99,d0
\0:
 moveq #4,d1
\1:
 move.l (a1)+,(a0)+
 dbra d1,\1
 add.w #10,a0
 dbra d0,\0
\2:
 rts


; *a0 : font,x,y,string,0
; d0 : parameter
Screen_DrawStr:
 move.l d0,-(a7)
 clr.w d0
 move.b (a0)+,d0
 move.l a0,-(a7)
 move.w d0,-(a7)
 move.l $c8,a0
 move.l 399*4(a0),a0
 jsr (a0)
 lea 2(a7),a7
 move.l (a7)+,a0
 move.l (a7)+,d0
 clr.w d1
 clr.w d2
 move.b (a0)+,d1
 move.b (a0)+,d2
 lea -32(a7),a7
 move.l a7,a1
 move.w #4,-(a7)
 move.l a1,-(a7)
 move.w d2,-(a7)
 move.w d1,-(a7)
 move.l d0,-(a7)
 move.l a0,-(a7)
 move.l a1,-(a7)
 move.l $c8,a0
 move.l 83*4(a0),a0
 jsr (a0)
 lea 12(a7),a7
 move.l $c8,a0
 move.l 425*4(a0),a0
 jsr (a0)
 lea 32+10(a7),a7
 rts

Keyboard_Update:
 move.b bKeys(a6),bLastKeys(a6)
 move.b $60001b,bKeys(a6)
 rts

Keyboard_Wait:
\0:
 bsr Keyboard_Update
 move.b bKeys(a6),d0
 move.b bLastKeys(a6),d1
 eor.b d0,d1
 beq \0
 and.b d1,d0
 bne \0
 rts

Random:
 move.l	d1,-(a7)
 move.w	wRandomSeed(a6),d1
 mulu.w	#31421,d1
 add.w	#6927,d1
 mulu.w	d1,d0
 move.w	d1,wRandomSeed(a6)
 clr.w	d0
 swap	d0
 move.l	(a7)+,d1
 rts

Time_Update:
 subq.l #1,uTime(a6)
 bmi \9
 move.l uTime(a6),d0
 divu.w #(MAX_TIME/20),d0
 btst #7,uTime+3(a6)
 beq \0
 addq.w #1,d0
\0:
 move.l pScreen(a6),a0
 add.l #2880,a0
 move.b #$ff,d1
\1: 
 move.b d1,30(a0)
 move.b d1,60(a0)
 move.b d1,90(a0)
 move.b d1,(a0)+
 dbra d0,\1
\9:
 rts
Scrolling_Update:
 move.w wScrollingX(a6),d1
 move.w A_x+Actors(a6),d0
 sub.w d1,d0
 sub.w #70,d0
 blt \0
 add.w d0,d1
\0:
 tst.w d1
 bgt \2
 clr.w d1
\2: 
 move.w wRoomWidth(a6),d0
 sub.w #20,d0
 lsl.w #3,d0
 cmp.w d0,d1
 blt \3
 move.w d0,d1
\3:
 move.w d1,wScrollingX(a6)
 rts

Room_Load:
 move.l pWarp(a6),a1
 move.l pWarpSave(a6),a2
 move.l pOldScreen(a6),a3
 move.b bGameFlags(a6),d1
 move.w wCoins(a6),d2
 move.w wLives(a6),d3
 move.l uScore(a6),d4
 move.l uTime(a6),d5
 move.b A_State+Actors(a6),d6
 move.w #((HEAP_USED/2)-1),d0
 move.l a6,a0
\0:
 clr.w (a0)+
 dbra d0,\0
 move.l a3,pOldScreen(a6)
 move.l a2,pWarpSave(a6)
 move.b d1,bGameFlags(a6)
 move.w d2,wCoins(a6)
 move.w d3,wLives(a6)
 move.l d4,uScore(a6)
 move.l d5,uTime(a6)
 and.b #(ASS_BIG+ASS_CAN_FIRE),d6
 move.b d6,A_State+Actors(a6)
 move.b #8,A_Width+Actors+1(a6)
 move.b #8,A_Height+Actors+1(a6)
 lea Mario_Update(pc),a0
 move.l a0,A_pUpdate+Actors(a6)
 bclr #GF_START_GAME,bGameFlags(a6)
 beq \1
 lea DefaultWarp(pc),a1
 clr.w wCoins(a6)
 move.w #3,wLives(a6)
 clr.l uScore(a6)
 clr.b A_State+Actors(a6)
\1:
 btst #AS_BIG,A_State+Actors(a6)
 beq \2
 addq.b #8,A_Height+Actors+1(a6)
\2:
 move.l a1,pWarp(a6)
 btst #7,(a1)
 beq \3
 move.l a1,pWarpSave(a6)
 move.l #MAX_TIME,uTime(a6)
\3:
 tst.b 1(a1)
 bne \4
 or.b #(GFS_END_GAME+GFS_WIN),bGameFlags(a6)
\4:
 move.l #$4c00,pScreen(a6)
 
 btst #GF_WIN,bGameFlags(a6)
 beq \5
 bset #GF_END_GAME,bGameFlags(a6)
 pea s_Win(pc)
 bra \9
\5:
 btst #GF_GAME_OVER,bGameFlags(a6)
 beq \6
 bset #GF_END_GAME,bGameFlags(a6)
 pea s_GameOver(pc)
 bra \9
\6:
 bclr #GF_TIME_UP,bGameFlags(a6)
 beq \10
 pea s_TimeUp(pc)
\9:
 bsr Screen_Clear
 move.l (a7)+,a0
 bsr Screen_DrawStr
 bsr Keyboard_Wait
 btst #GF_GAME_OVER,bGameFlags(a6)
 bne \20
 btst #GF_WIN,bGameFlags(a6)
 bne \20
\10:
 move.l pWarp(a6),a0
 btst #7,(a0)
 beq \20
 bsr Screen_Clear
 lea s_Version(pc),a0
 bsr Screen_DrawStr
 lea s_Status(pc),a0
 bsr Screen_DrawStr
 clr.l d0 
 move.w wLives(a6),d0
 lea s_Lives(pc),a0
 bsr Screen_DrawStr 
 clr.l d0 
 move.w wCoins(a6),d0
 lea s_Coins(pc),a0
 bsr Screen_DrawStr 
 lea s_Key0(pc),a0
 bsr Screen_DrawStr 
 lea s_Key1(pc),a0
 bsr Screen_DrawStr 
 lea s_Key2(pc),a0
 bsr Screen_DrawStr 
 lea s_Key3(pc),a0
 bsr Screen_DrawStr 
 bsr Keyboard_Wait
 btst #7,bKeys(a6)
 bne \20
 bset #GF_END_GAME,bGameFlags(a6)
\20: 
 btst #GF_END_GAME,bGameFlags(a6)
 beq \21
 bsr Screen_Clear
 lea s_Loadall0(pc),a0
 bsr Screen_DrawStr
 lea s_Loadall1(pc),a0
 bsr Screen_DrawStr
 lea s_Web0(pc),a0
 bsr Screen_DrawStr
 lea s_Web1(pc),a0
 bsr Screen_DrawStr
 lea s_EMail0(pc),a0
 bsr Screen_DrawStr
 lea s_EMail1(pc),a0
 bsr Screen_DrawStr
 bsr Keyboard_Wait
 rts
\21:
 lea VirtualScreen+210(a6),a0
 move.l a0,pScreen(a6)

 move.b #(AFS_INUSE+AFS_COLLISION_ITEMS),A_Flags+Actors(a6)
 move.l pWarp(a6),a1
 addq.w #1,a1
 clr.w d0
 move.b (a1)+,d0
 add.w d0,d0
 lea RoomPtrs(pc),a0
 add.w 0(a0,d0.w),a0
 move.w (a1)+,d0
 move.w d0,A_x+Actors(a6)
 subq.w #8,d0
 move.w d0,wScrollingX(a6)
 move.w (a1),A_y+Actors(a6)
 move.w (a0)+,wRoomWidth(a6)
 move.l a0,pRoomExtraData(a6)
\28:
 add.w #10,a0
 tst.w (a0)
 bne \28
 addq.w #2,a0
 lea Room(a6),a1
CodeSize = 0
MaxCode = CodeSize+2
FreeCode = MaxCode+2
LastChar = FreeCode+2
LastCode = LastChar+2
CurrCode = LastCode+2
BitShift = CurrCode+2
Fathers = BitShift+2
Characters = Fathers+$800
Stack = Characters+$400
 lea VirtualScreen(a6),a2
 lea Fathers(a2),a3
 lea Characters(a2),a4
 clr.w BitShift(a2)
 move.w #$ff,d0
\29:
 move.w d0,d1
 add.w d1,d1
 move.w #$100,0(a3,d1.w)
 move.b d0,0(a4,d0.w)
 dbra d0,\29
\30:
 move.w #9,CodeSize(a2)
 move.w #$1ff,MaxCode(a2)
 move.w #$102,FreeCode(a2)
 bsr \GetCode
 cmp.w #$101,d0
 beq \90
 cmp.w #$100,d0
 beq \30
 move.w d0,LastChar(a2)
 move.w d0,LastCode(a2)
 move.b d0,(a1)+
\40:
 bsr \GetCode
 cmp.w #$101,d0
 beq \90
 cmp.w #$100,d0
 beq \30
 move.w d0,CurrCode(a2)
 lea Stack(a2),a5
 cmp.w FreeCode(a2),d0
 bmi \50
 move.b LastChar(a2),(a5)+
 move.w LastCode(a2),d0
\50:
 move.b 0(a4,d0.w),(a5)+
 add.w d0,d0
 move.w 0(a3,d0.w),d0
 cmp.w #$100,d0
 bne \50
 subq.w #1,a5
 move.b (a5),LastChar(a2)
 move.l a5,d0
 sub.l a2,d0
 sub.w #Stack,d0
 addq.w #1,a5
\60:
 move.b -(a5),(a1)+
 dbra d0,\60
 move.w FreeCode(a2),d0
 cmp.w MaxCode(a2),d0
 bmi \70
 cmp.w #$a,CodeSize(a2)
 beq \40
 addq.w #1,CodeSize(a2)
 move.w MaxCode(a2),d1
 add.w d1,d1
 addq.w #1,d1
 move.w d1,MaxCode(a2)
\70:
 addq.w #1,FreeCode(a2)
 move.b LastChar(a2),0(a4,d0.w)
 add.w d0,d0
 move.w LastCode(a2),0(a3,d0.w)
 move.w CurrCode(a2),LastCode(a2)
 bra \40 
\90: 
 rts
\GetCode:
 move.w BitShift(a2),d1
 cmp.w #$10,d1
 bmi \99
 sub.w #$10,d1
 addq.w #2,a0
\99:
 move.w 2(a0),d0
 swap d0
 move.w (a0),d0
 lsr.l d1,d0
 and.w MaxCode(a2),d0
 add.w CodeSize(a2),d1
 move.w d1,BitShift(a2)
 rts

; (d6.w,d7.w) : (x,y)
; => a0 : extra data
Room_GetExtraData:
 move.l pRoomExtraData(a6),a0
\0:
 cmp.w (a0)+,d6
 bne \1 
 cmp.w (a0)+,d7
 bne \2
 rts
\1:
 addq.w #2,a0
\2:
 addq.w #6,a0
 bra \0

Room_Update:
 move.w wScrollingX(a6),d6
 lea Room(a6),a5
 lsr.w #3,d6
 add.w d6,a5
 lsl.w #3,d6
 clr.w d7
 moveq #11,d0
\0:
 moveq #20,d1
\1:
 move.b (a5)+,d5
 beq \2
 movem.w d0/d1/d6/d7,-(a7)
 clr.w d0
 move.b d5,d0
 add.w d0,d0
 lea Items_UpdatePtrs(pc),a0
 add.w 0(a0,d0.w),a0
 jsr (a0)
 movem.w (a7)+,d0/d1/d6/d7
\2:
 addq.w #8,d6
 dbra d1,\1
 sub.w #21,a5
 add.w wRoomWidth(a6),a5
 sub.w #168,d6
 addq.w #8,d7
 dbra d0,\0
 rts

 include "Actors.inc"
 
Items_UpdatePtrs:
 include "Items.inc"
 include "Bitmaps.inc"

DefaultWarp:
 dc.b $80,1
 dc.w 1*8,1*8
 
RoomPtrs:
\0:
 dc.w 0
 dc.w  Room001-\0
 dc.w  Room002-\0
 dc.w  Room003-\0
 dc.w  Room004-\0
 dc.w  Room005-\0
 dc.w  Room006-\0
 
Room001:
 dc.w 305
 dc.w 43*8,8*8
 dc.b 0,2
 dc.w 16,0
 dc.w 103*8,8*8
 dc.b 0,3
 dc.w 16,0
 dc.w 303*8,10*8
 dc.b $82,4
 dc.w 16,8
 dc.w 303*8,1*8
 dc.b $82,4
 dc.w 16,8
 dc.w 290*8,4*8
 dc.b 2,$50
 dc.w 200,0
 dc.w 293*8,2*8
 dc.b 2,$05
 dc.w 200,200
 dc.w 0
 incbin "Room001.lzw"
Room002:
 dc.w 20
 dc.w 15*8,10*8
 dc.b 1,1
 dc.w 45*8,9*8
 dc.w 0
 incbin "Room002.lzw"
Room003:
 dc.w 20
 dc.w 15*8,3*8
 dc.b 1,1
 dc.w 105*8,9*8 
 dc.w 0 
 incbin "Room003.lzw"
Room004:
 dc.w 284
 dc.w 108*8,4*8
 dc.b 2,$04
 dc.w 200,0
 dc.w 115*8,4*8
 dc.b 2,$70
 dc.w 350,0
 dc.w 190*8,3*8
 dc.b 2,$50
 dc.w 200,0
 dc.w 195*8,3*8
 dc.b 2,$50
 dc.w 200,200
 dc.w 200*8,3*8
 dc.b 2,$50
 dc.w 200,0
 dc.w 228*8,4*8
 dc.b 2,$07
 dc.w 350,0
 dc.w 269*8,3*8
 dc.b 2,$60
 dc.w 250,0
 dc.w 282*8,1*8
 dc.b $82,5
 dc.w 8,9*8
 dc.w 282*8,10*8
 dc.b $82,5
 dc.w 8,9*8
 dc.w 0 
 incbin "Room004.lzw"
Room005:
 dc.w 300
 dc.w 80*8,6*8
 dc.b 0,6
 dc.w 8,0
 dc.w 296*8,6*8
 dc.b $2,0
 dc.w 8,8
 dc.w 0
 incbin "Room005.lzw"
Room006:
 dc.w 20
 dc.w 15*8,2*8
 dc.b 1,5
 dc.w 45*8,-1*8
 dc.w 0
 incbin "Room006.lzw"

s_Version: dc.b 1,0,0,"v1.04",0
s_Status: dc.b 1,60,0,"Status",0
s_Lives: dc.b 2,50,20,"%lu Lives",0
s_Coins: dc.b 2,50,40,"%lu Coins",0
s_Key0: dc.b 1,65,60,"Keys",0
s_Key1: dc.b 1,0,70,"[2ND] : Jump",0
s_Key2: dc.b 1,0,80,"[DIAMOND] : Fire",0
s_Key3: dc.b 1,0,90,"[ALPHA] : Pause/Quit",0
s_Pause: dc.b 2,60,40,"PAUSE",0
s_Win: dc.b 2,40,40,"You Won!",0
s_GameOver: dc.b 2,40,40,"Game Over",0
s_TimeUp: dc.b 2,40,40,"Time Up",0
s_Loadall0: dc.b 1,40,10,"Programmed by",0
s_Loadall1: dc.b 2,50,20,"LOADALL",0
s_Web0: dc.b 1,60,60,"Web:",0
s_Web1: dc.b 2,0,70,"loadall.planet-d.net",0
s_EMail0: dc.B 1,55,80,"EMail:",0
s_EMail1: dc.b 2,3,90,"loadall@hotmail.com",0
 end